<template>
    <div id="main-menu">
        <v-navigation-drawer
            v-model="drawer"
            class="hidden-md-and-up"
            app
            clipped
            right
        >
            <v-list dense>
                <v-list-item
                    v-for="(item, index) in menuToShow"
                    :key="index"
                    @click="item.fct"
                    link
                >
                    <v-list-item-action>
                        <v-icon>{{ item.icon }}</v-icon>
                    </v-list-item-action>
                    <v-list-item-content>
                        <v-list-item-title>{{ item.text }}</v-list-item-title>
                    </v-list-item-content>
                </v-list-item>
            </v-list>
        </v-navigation-drawer>

        <v-app-bar app clipped-right>
            <div class="d-flex align-center">
                <v-img
                    id="brand-icon"
                    alt="Impulsy Logo"
                    class="shrink mr-2"
                    contain
                    src="images/impulsy_logo.png"
                    transition="scale-transition"
                    width="40"
                    @click="onGoTo({ name: 'Home' })"
                />
            </div>

            <v-spacer></v-spacer>

            <v-toolbar-items class="hidden-sm-and-down">
                <v-btn
                    v-for="(item, index) in menuToShow"
                    :key="index"
                    @click="item.fct"
                    text
                    ><v-icon left>{{ item.icon }}</v-icon>
                    {{ item.text }}</v-btn
                >
            </v-toolbar-items>

            <v-app-bar-nav-icon
                class="hidden-md-and-up"
                @click.stop="drawer = !drawer"
            />
        </v-app-bar>
        <login-and-registration
            :show="showLogin"
            :success="loginSuccess"
            :error="loginError"
            :cancel="
                () => {
                    showLogin = false;
                }
            "
        />
    </div>
</template>

<script>
import LoginAndRegistration from './LoginAndRegistration';

export default {
    name: 'MainMenu',

    components: {
        'login-and-registration': LoginAndRegistration
    },

    data() {
        return {
            drawer: false,
            showLogin: false,
            menu: [
                {
                    icon: 'mdi-controller-classic',
                    text: 'Game',
                    fct: () => {
                        this.onGoTo({ name: 'GameMenu' });
                    }
                },
                {
                    icon: 'mdi-trophy',
                    text: 'Hof',
                    fct: () => {
                        this.onGoTo({ name: 'HoF' });
                    }
                },
                {
                    icon: 'mdi-account',
                    text: 'Profil',
                    fct: () => {
                        this.onGoTo({ name: 'Profil' });
                    },
                    auth: true
                },
                {
                    icon: 'mdi-logout',
                    text: 'Logout',
                    fct: this.onLogout,
                    auth: true
                },
                {
                    icon: 'mdi-login',
                    text: 'Login',
                    fct: this.onLogin,
                    auth: false
                }
            ]
        };
    },

    computed: {
        menuToShow: function() {
            if (this.$store.getters.isAuth) {
                return this.menu.filter(
                    item => item.auth === undefined || item.auth === true
                );
            } else {
                return this.menu.filter(
                    item => item.auth === undefined || item.auth === false
                );
            }
        }
    },

    methods: {
        onLogout() {
            this.$store.commit('logout');
            this.$route.name == 'Home'
                ? this.$router.go()
                : this.$router.push({ name: 'Home' });
        },

        onLogin() {
            this.showLogin = true;
        },

        onGoTo(route) {
            this.$router.push(route);
        },

        loginSuccess() {},

        loginError(error) {
            console.log(error);
        }
    },

    created() {
        //this.$vuetify.theme.dark = true
    }
};
</script>

<style scoped>
#brand-icon {
    cursor: pointer;
}
</style>
